# Gosse Adema

import RPi.GPIO as GPIO
import time

GPIO.setmode(GPIO.BCM)

def report_keyboard(c,k):
    with open('/dev/hidg0', 'rb+') as fk:
        fk.write((c).to_bytes(1, byteorder='big')+    \
                 (0).to_bytes(1, byteorder='big')+    \
                 (k[0]).to_bytes(1, byteorder='big')+ \
                 (k[1]).to_bytes(1, byteorder='big')+ \
                 (k[2]).to_bytes(1, byteorder='big')+ \
                 (k[3]).to_bytes(1, byteorder='big')+ \
                 (k[4]).to_bytes(1, byteorder='big')+ \
                 (k[5]).to_bytes(1, byteorder='big'))

MaxtrixRows = [8, 25, 7, 24, 23]
MaxtrixCols = [18, 4, 17, 27, 22, 10, 9, 6, 13, 19, 26, 21, 20, 16, 12]

Hid = [[  53,  30,  31,  32,  33,  34,  35,  36,  37,  38,  39,  45,  46,  42,   0]
      ,[   0,  43,  20,  26,   8,  21,  23,  28,  24,  12,  18,  19,  47,  48,  49]
      ,[   0,   2,   4,  22,   7,   9,  10,  11,  13,  14,  15,  51,  52,  40,   0]
      ,[   0,  -2,  29,  27,   6,  25,   5,  17,  16,  54,  55,  56, -32,  82,   0]
      ,[   0,  -1,  -8,  -4,   1,  44,   0,  44,   1, -64,-128, -16,  80,  81,  79]]

HFn = [[  41,  58,  59,  60,  61,  62,  63,  64,  65,  66,  67,  68,  69,  42,   0]
      ,[   0,  43,  41,   0,   0,   0,   0,  75,  74,  82,  77,  76,  70,  71,  72]
      ,[   0,   2,  57,   0,   0,   0,   0,  78,  80,  81,  79,  73,   0,  40,   0]
      ,[   0,  -2,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, -32,  82,   0]
      ,[   0,  -1,  -8,  -4,   1,  44,   0,  44,   1, -64,-128, -16,  80,  81,  79]]

KeyMouse   = [2,1] # used for quick identification of layers
KeyFnLeft  = [4,4]
KeyFnRight = [4,8]
KeyMod     = [4,5]

OldCtrl = 0
OldKeys = [0,0,0,0,0,0]

for RowValue in MaxtrixRows:
   GPIO.setup(RowValue, GPIO.IN, pull_up_down = GPIO.PUD_DOWN)

for ColValue in MaxtrixCols:
   GPIO.setup(ColValue, GPIO.OUT)
   GPIO.output(ColValue, 0)

while True:

   time.sleep (0.05)

   #
   # KeyScan
   #

   KeyStack = []

   ColNo = 0
   for ColValue in MaxtrixCols:
      GPIO.output(ColValue, 1)

      RowNo = 0
      for RowValue in MaxtrixRows:
         if(GPIO.input(RowValue) == 1):
            KeyStack.append([RowNo, ColNo])
         RowNo = RowNo + 1

      GPIO.output(ColValue, 0)
      ColNo = ColNo + 1

   #
   # KeyProcessor
   #

   HidList = []
   HidCtrl = HFnCtrl = FnPress = Pressed = 0

   # Function Layer
   if KeyStack.count (KeyFnLeft) + KeyStack.count (KeyFnRight) > 0:

      for r,c in KeyStack:
         Key = HFn [r][c]

         if Key < 0:
            HidCtrl = HidCtrl - Key

         elif Key >= 4:
            HidList.append (Key)
            Pressed = Pressed + 1

   # Mouse Layer
   elif KeyStack.count (KeyMouse):
      print ('mouse')

   # Regular Layer
   else:
      for r,c in KeyStack:
         Key = Hid [r][c]

         if Key < 0: # Control keys
            HidCtrl = HidCtrl - Key

         elif Key >= 4: # No Layer keys (1,2 or 3)
            HidList.append (Key)
            Pressed = Pressed + 1

   # No duplicates and 6 values for the keys
   UseCtrl = HidCtrl
   UseList = list(dict.fromkeys(HidList))

   # Always 6 bytes
   for i in range (len(UseList), 6):
      UseList.append (0)

   # Only report errors or changes
   if Pressed > 6:
      report_keyboard(0 ,[1,1,1,1,1,1])
      print ('error')
      OldCtrl = 0
      OldKeys = [0,0,0,0,0,0]

   else:
      if ((OldKeys > UseList) - (OldKeys < UseList)) != 0 or (OldCtrl != UseCtrl):
         report_keyboard(UseCtrl,UseList)
         OldCtrl = UseCtrl
         OldKeys = UseList

GPIO.cleanup()